import java.util.*;

/**
 * A utility class to test the searching and sorting methods.
 * 
 * @author YOUR NAMES HERE
 */
public class EfficiencyTester
{	
	public static void main(String[] args)
    {
		//example arrays of numbers
		Integer[] nums = {6,5,3,1,8,7,2,4};
    	Integer[] hundred = shuffled(100, 512);
    	printArray(hundred); //demonstration of printing method
    	Integer[] million = shuffled((int)Math.pow(10,6), 512);

    	
    	//TODO Method Testing code goes here!

    	
     }


	//Below are utility methods to use (no modification needed)
	
	
	/**
	 * Returns a shuffled (randomly sorted) array of integers from 1 to the given number
	 * @param n The number of numbers to shuffle
	 * @param seed A random seed, if less than 0 then unseeded
	 * @return An array of shuffled integers
	 */
	public static Integer[] shuffled(int n, int seed)
	{
		ArrayList<Integer> nums = new ArrayList<Integer>();
		for(int i=0; i<n; i++)
		{
			nums.add(i+1);
		}
		if(seed >= 0)
			Collections.shuffle(nums, new Random(seed));
		else
			Collections.shuffle(nums);
		return nums.toArray(new Integer[0]);		
	}

	/**
	 * Creates an ordered array of numbers from 1 to n; order can be specified in reverse
	 * @param n The size of the array
	 * @param ascending whether the array should be ascending (if false, will be decending)
	 * @return The ordered array
	 */
	public static Integer[] ordered(int n, boolean ascending)
	{
		Integer[] array = new Integer[n];
		if(ascending)
		{
			for(int i=0; i<n; i++)
				array[i] = i+1;
		}
		else
		{
			for(int i=0; i<n; i++)
				array[i] = n - i;
		}	
		return array;
	}

	
    /**
     * Prints out the given array, with every 20th number on a new line (for readability)
     * @param numbers The array to print out
     */
    public static void printArray(Integer[] numbers)
    {
        for(int i=0; i<numbers.length; i++)
        {
            System.out.print(numbers[i]+", ");
            if(i > 0 && i%20 == 0) //every 20th number, go to the next line
                System.out.println();
        }
        System.out.println();
    }

	
}
